// C-Programmierung Beleg 7
// Copyright: Matthias Jauernig, 2005
#include "liste.h"
#include "datenfile.h"
#include "indexfile.h"
#include "c_beleg7.h"
#include <stdio.h>
#include <errno.h>

// Return-Codes der Funktionen, die char zurck geben
//  retval=0: kein Fehler
//  retval=1: Rckgabe mit Fehler ohne Fehlermeldung oder Abbruch durch Benutzer
//  retval=2: Rckgabe mit Fehler, zu dem Fehlermeldung ausgegeben werden kann

/* --- main() ---------------------------------------------------------------------------------	*/
int main(int argc, char **argv){					//argv[1] ist evtl. filename
	char abfrage, *datenfile, *indexfile=NULL;
	char retval;

	if(pruefeExistenzDatenfile(argc,argv,&datenfile)!=0)
		return 1;
	
	do{
		printf("\n-------------\n"
		       "| Hauptmenu |\n"
		       "-------------\n");
		printf("(1) Eingabe eines Datensatzes\n"
		       "(2) Sequentielle Ausgabe des Datenfiles\n"
		       "(3) Datensatz aendern\n"
		       "(4) Indexfile erstellen\n"
		       "(5) Sortierte Ausgabe mit Indexfile\n"
		       "(6) Nach Namen suchen\n"
		       "(7) Verlassen\n"
		       "> ");
		abfrage=getchar();  Fflush();
		
		retval=0;
		switch(abfrage){
			case '1':	retval=eingabeDatenfile(datenfile);			break;
			case '2':	retval=ausgabeDatenfile(datenfile);			break;
			case '3':	retval=aendernDatenfile(datenfile);			break;
			case '4':	retval=erstelleIndexfile(datenfile,&indexfile);		break;
 			case '5':	retval=sortAusgabeDatenfile(datenfile,indexfile);	break;
			case '6':	retval=sucheNachNamen(datenfile,indexfile);		break;
			case '7':	break;
			default:	printf("Ungueltige Nummer!\n");
		}
		if(indexfile && retval==0 && (abfrage=='1' || abfrage=='3'))
			retval=erstelleIndexfile(datenfile,&indexfile);
		if(retval==2)
			perror("Fehler");
	}while(abfrage!='7');

	return 0;
}
