#include "c_beleg7.h"
#include "datenfile.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char eingabeDatenfile(char *filename){
	datensatz neu;
	FILE *fp=fopen(filename, "ab");					//Schreiben im Append-Modus
	if(!fp) return 2;
	printf("Name eingeben:     ");
	fgets(neu.name,30,stdin); neu.name[strlen(neu.name)-1]='\0';
	printf("Vorname eingeben:  ");
	fgets(neu.vorname,20,stdin); neu.vorname[strlen(neu.vorname)-1]='\0';
	printf("Adresse eingeben:  ");
	fgets(neu.adresse,50,stdin); neu.adresse[strlen(neu.adresse)-1]='\0';
	if(!fwrite(&neu,sizeof(neu),1,fp)){
		fclose(fp);
		return 2;
	}
	fclose(fp);
	return 0;
}

char ausgabeDatenfile(char *filename){
	int i=1;
	datensatz neu;
	FILE *fp=fopen(filename, "rb");					//Lesen im Lese-Modus
	if(!fp) return 2;
	while(fread(&neu,sizeof(neu),1,fp)){
		printf("\nDatensatz Nr. %d:\n",i++);
		printf("Name:     %s\n",neu.name);
		printf("Vorname:  %s\n",neu.vorname);
		printf("Adresse:  %s\n",neu.adresse);
	}
	if(ferror(fp)){
	 	fclose(fp);
		return 2;
	}
	fclose(fp);
	return 0;
}

char aendernDatenfile(char *filename){
	int i, nr;
	char abfrage, zk[50];
	datensatz neu;
	FILE *fp=fopen(filename, "rb+");				//R/W im Update-Modus
	if(!fp) return 2;
	printf("\nNr. des zu aendernden Datensatzes?: ");
	scanf("%d",&nr); Fflush();
	if(fseek(fp,0,SEEK_END)==-1){					//Dateiende lesen
		fclose(fp);
		return 2;
	}
	i=ftell(fp);							//Bytes bis zur akt. Filepos
	if(i/sizeof(datensatz)<nr){					//wenn nr ber Fileende
		printf("Soviele Datensaetze sind im File nicht vorhanden!\n");
		fclose(fp);
		return 1;
	}
	
	if(fseek(fp,(nr-1)*sizeof(neu),SEEK_SET)==-1){			//zu Datensatz nr spulen
		fclose(fp);
		return 2;
	}
	if(!fread(&neu,sizeof(neu),1,fp)){				//Datensatz lesen
		fclose(fp);
		return 2;
	}
	printf("\nDatensatz Nr. %d:\n",nr);
	printf("Name:     %s\n",neu.name);
	printf("Vorname:  %s\n",neu.vorname);
	printf("Adresse:  %s\n",neu.adresse);
	printf("=> Soll dieser Datensatz wirklich geaendert werden (j/n)?: ");
	abfrage=getchar(); Fflush();
	if(abfrage!='j' && abfrage!='J'){
		fclose(fp);
		return 1;
	}
	
	printf("Name eingeben:     ");
	fgets(zk,30,stdin); zk[strlen(zk)-1]='\0';
	if(strcmp(zk,"")!=0) strncpy(neu.name,zk,30);
	printf("Vorname eingeben:  ");
	fgets(zk,20,stdin); zk[strlen(zk)-1]='\0';
	if(strcmp(zk,"")!=0) strncpy(neu.vorname,zk,20);
	printf("Adresse eingeben:  ");
	fgets(zk,50,stdin); zk[strlen(zk)-1]='\0';
	if(strcmp(zk,"")!=0) strncpy(neu.adresse,zk,50);
	
	if(fseek(fp,-sizeof(neu),SEEK_CUR)==-1){			//einen Datensatz zurck spulen
		fclose(fp);
		return 2;
	}
	if(!fwrite(&neu,sizeof(neu),1,fp)){
		fclose(fp);
		return 2;
	}
	fclose(fp);
	return 0;
}

char pruefeExistenzDatenfile(int argc, char **argv, char **datenfile){
	FILE *fp;
	
	char abfrage='j';
	do{
		if(argc==1 || (abfrage!='j' && abfrage!='J')){
			*datenfile=(char*)malloc(100);
			printf("\nEinzulesende Datei angeben: ");
			scanf("%s", *datenfile); Fflush();
		}
		else *datenfile=argv[1];					//filenamen lesen
	
		fp=fopen(*datenfile,"rb");				//File existent?
		if(!fp){						//Datei existiert nicht
			perror("Fehler");
			printf("Datei neu anlegen (j/n, q=quit)?: ");
			abfrage=getchar(); Fflush();
			if(abfrage=='J' || abfrage=='j')
				fp=fopen(*datenfile,"ab");		//File anlegen (Append-Modus)
			else if(abfrage=='Q' || abfrage=='q') 
				return 1;				//Quit
			else if((*datenfile)!=argv[1]) free(*datenfile);
		}
		else abfrage='j';					//Datei existiert, daher weiter
	}while(abfrage!='j' && abfrage!='J');
	fclose(fp);
	
	return 0;
}

